#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <dos.h>
#include <string.h>
#include <fstream.h>

extern "C"
{
	#include "detect.h"
	#include "smix.h"
}

#include "Aa3Game.H"
#include "Aa3Anim.H"
#include "Aa3Draw.H"
#include "Aa3Kybd.H"
#include "Aa3Scrns.H"
#include "Aa3Const.H"

// externs in hkkybd
extern char EscFlag;


unsigned long time_elapsed, score;
char dead, quit;
char locked_on_switched; // flag
char dashboard_change;



void init(EShipPtr &E, YShip &Y, YProjsPtr &YP, EProjsPtr &EP, int_coords S[], ETypePtr &ET, int &numET);
void un_init(EShipPtr &E, YProjsPtr &YP, EProjsPtr &EP, ETypePtr &ET);


void RunGame(void)
{
	EShipPtr E, locked_on;
   YShip Y;
   YProjsPtr YP;
   EProjsPtr EP;
   ETypePtr ET;
   int_coords S[NUM_STARS];
	char level=1;
   unsigned long Erate;  // rate of enemies coming on screen
                         //  (millisecs between each appearance)
   unsigned long lastadd, lastshoot, last_star_update;
   int numET;
   unsigned long up_score;
   char lev_str[] = "Level 25";
   char num_str[] = "25";

   // game play

   score = 0;

   do
   {
   	cleardevice();
      setviewport(0, 0, 639, 479, 1);
      settextjustify(CENTER_TEXT, CENTER_TEXT);
      settextstyle(TRIPLEX_FONT, HORIZ_DIR, 4);
      setcolor(LIGHTGREEN);
      strcpy(lev_str, "Level ");
      itoa(level, num_str, 10);
      strcat(lev_str, num_str);
      outtextxy(320, 240, lev_str);
      settextjustify(LEFT_TEXT, CENTER_TEXT);
      settextstyle(SMALL_FONT, HORIZ_DIR, 4);
      outtextxy(5, 473, "Press ESC to continue");

      #pragma warn -eff
      while (!EscFlag) ;
      while (EscFlag) ;
      #pragma warn .eff

      cleardevice();

      setviewport(0, 20, 639, 459, 1);
   	init(E, Y, YP, EP, S, ET, numET);
		DrawDashboard();
      dashboard_change = 0;
      lastadd=0;
      lastshoot=0;
      last_star_update=0;
      dead=0;
      quit=0;
      time_elapsed = 0;
      Erate = E_RATE_COEFF/(level);
      locked_on = NULL;
      locked_on_switched = 0;
      up_score = (unsigned long)level*(unsigned long)UP_LEVEL_SCORE;

      do
      {
      	DrawYShip(Y.x, Y.y, Y.aim);
      	AnimateY(Y, E, locked_on);
         AnimateYP(YP, E, locked_on);
         AnimateEP(EP, Y);
         AnimateE(E, locked_on, EP, Y, ET);
         if (last_star_update + STAR_UPDATE_WAIT <= time_elapsed)
         {
         	AnimateS(S, Y);
            last_star_update = time_elapsed;
         }
         if (dashboard_change)
         {
         	UpdateDashboard(Y);
            dashboard_change = 0;
         }
         if (lastadd + Erate <= time_elapsed)
         	if (random(4) == 0)
            {
            	AddAlien(E, random(numET)+1, ET);
               lastadd = time_elapsed;
            }
         ChkKybd(Y, YP, lastshoot, quit);
      	delay(WAIT_TIME);
         time_elapsed += WAIT_TIME;
      } while (!dead && !quit && !(score >= up_score));

      un_init(E, YP, EP, ET);

      level++;
   } while (!dead && !quit && (level <= 25));

   if (!dead && !quit)
   	Win();
   else if (dead)
   	Dead();

   setviewport(0, 0, 639, 479, 1);
}



void init(EShipPtr &E, YShip &Y, YProjsPtr &YP, EProjsPtr &EP, int_coords S[], ETypePtr &ET, int &numET)
{
   int i;

	E = new EShip;
   E->prev = E->next = E;

   Y.shields = Y.power = 100;
   Y.bearing.theta = 3.14159/2;
   Y.bearing.mag = 0;
   Y.x = 320;
   Y.y = 240;  // global coords
   Y.lastmov = Y.lastshoot = Y.lastacc = Y.lastturn = Y.lastrecharge = 0;
   Y.aim = 3.14159/2;

   YP = new YProjs;
   YP->prev = YP->next = YP;

   EP = new EProjs;
   EP->prev = EP->next = EP;

   for (i = 0; i < NUM_STARS; i++)
   {
   	S[i].x = random(640);
      S[i].y = random(430);
   }

   // load et stuff
   ifstream et_datafile("Aa3Ques.TXT");
   char tmp_strname[300];

   ET = new EType;
   ET->next = ET;
   ETypePtr cur = ET;

   et_datafile >> numET;

   for (i = 0; i < numET; i++)
   {
   	et_datafile.getline(tmp_strname, 300, '|');
   	cur->next = new EType;
      cur->next->question = new char[strlen(tmp_strname)+1];
      strcpy(cur->next->question, tmp_strname);
      et_datafile >> cur->next->answer;
      cur->next->next = ET;
      cur = cur->next;
   }
   et_datafile.close();
}

void un_init(EShipPtr &E, YProjsPtr &YP, EProjsPtr &EP, ETypePtr &ET)
{
	// delete all stuff.  REMEMBER: delete strings in ET

   EShipPtr Edel;
   while (E->next != E)
   {
   	Edel = E->next;
      E->next = Edel->next;
		delete Edel;
   }
   delete E;

   YProjsPtr YPdel;
   while (YP->next != YP)
   {
   	YPdel = YP->next;
      YP->next = YPdel->next;
      delete YPdel;
   }
   delete YP;

   EProjsPtr EPdel;
   while (EP->next != EP)
   {
   	EPdel = EP->next;
      EP->next = EPdel->next;
      delete EPdel;
   }
   delete EP;

	ETypePtr ETdel;
   while (ET->next != ET)
   {
   	ETdel = ET->next;
      delete [] ETdel->question;
      ET->next = ETdel->next;
      delete ETdel;
   }
   delete ET;
}
