#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>

extern "C"
{
	#include "detect.h"
	#include "smix.h"
}

#include "Aa3Anim.H"
#include "Aa3Math.H"
#include "Aa3Kybd.H"
#include "Aa3Draw.H"
#include "Aa3Const.H"
#include "Aa3Snds.H"

const int IntNum =  0x15;

const int _UP =     0x48;
const int _DOWN =   0x50;
const int _LEFT =   0x4B;
const int _RIGHT =  0x4D;
const int _1 =      0x02;
const int _2 =      0x03;
const int _3 =      0x04;
const int _4 =      0x05;
const int _ESC =    0x01;


// externs
extern unsigned long time_elapsed;
extern char dashboard_change;

extern SOUND *Sound[NUMSOUNDS]; // in dwsnds.cpp
extern char Music, SFX;


void interrupt (far *OldKbdVec)(...);
char _1Flag = 0,
     _2Flag = 0,
     _3Flag = 0,
     _4Flag = 0,
     UpFlag = 0,
     DownFlag = 0,
	  LeftFlag = 0,
	  RightFlag = 0,
	  EscFlag = 0;

void KbdExitProc(void)

{
	if (_dos_getvect(IntNum) != OldKbdVec)
		_dos_setvect(IntNum, OldKbdVec);
}

void interrupt far keyboard(...)

{
	int reg_ax = _AX;

	if ((reg_ax >> 8) == 0x4F)
   	switch (reg_ax & 0x00FF)
      {
      	case _UP           : UpFlag     = 1;
         							break;
         case _DOWN         : DownFlag   = 1;
         							break;
         case _LEFT         : LeftFlag   = 1;
         							break;
         case _RIGHT        : RightFlag  = 1;
         							break;
         case _1            : _1Flag   = 1;
         							break;
         case _2            : _2Flag = 1;
          							break;
         case _3            : _3Flag = 1;
         							break;
         case _4            : _4Flag = 1;
         							break;
         case _ESC          : EscFlag    = 1;
         							break;
         case _UP + 128     : UpFlag     = 0;
         							break;
         case _DOWN + 128   : DownFlag   = 0;
         							break;
         case _LEFT + 128   : LeftFlag   = 0;
         							break;
         case _RIGHT + 128  : RightFlag  = 0;
         							break;
         case _1 + 128      : _1Flag   = 0;
         							break;
         case _2 + 128      : _2Flag = 0;
          							break;
         case _3 + 128      : _3Flag = 0;
         							break;
         case _4 + 128      : _4Flag = 0;
         							break;
         case _ESC + 128    : EscFlag    = 0;
         							break;
         default				 : ;
      }
   if (reg_ax > 127)
		while (kbhit())
   		getch();
}

void InstallKyb(void)

{
	OldKbdVec = _dos_getvect(IntNum);
   atexit(KbdExitProc);
}

void UnsetKyb(void)

{
	_dos_setvect(IntNum, OldKbdVec);
}

void SetKyb(void)

{
	_dos_setvect(IntNum, keyboard);
}

void ClrKybBuf(void)

{
	while (kbhit())
   	getch();
}

void ClrFlags(void)

{
	_1Flag = _2Flag = _3Flag = _4Flag = 0;
   UpFlag = 0;
   DownFlag = 0;
	LeftFlag = 0;
	RightFlag = 0;
	EscFlag = 0;
}


void ChkKybd(YShip &Y, YProjsPtr YP, unsigned long &lastshoot, char &quit)
{
	YProjsPtr ins;

	if ((_1Flag||_2Flag||_3Flag||_4Flag) && lastshoot + Y_REFIRE_WAIT <= time_elapsed && Y.power >= BULLET_POWER)
   {
   	ins = new YProjs;
      if (_1Flag)
   		ins->answer = 1;
      else if (_2Flag)
      	ins->answer = 2;
      else if (_3Flag)
      	ins->answer = 3;
      else if (_4Flag)
      	ins->answer = 4;
      ins->bearing = add_vect(Y.bearing.theta, Y.bearing.mag, Y.aim, BULLET_FIRE_MAG);
      ins->x = Y.x + (Y_SIDE_LENGTH+1) * cos(ins->bearing.theta);
      ins->y = Y.y + (Y_SIDE_LENGTH+1) * sin(ins->bearing.theta);
      ins->lastmove = 0;
      ins->range = Y_BULLET_RANGE;
      ins->prev = YP;
      ins->next = YP->next;
      YP->next = ins;
      ins->next->prev = ins;
      Y.power -= BULLET_POWER;
      dashboard_change = 1;
      lastshoot = time_elapsed;
      if (SFX)
      	start_sound(Sound[1], 1, 0);
   }

   if (UpFlag && DownFlag) ;
   else if (UpFlag && Y.lastacc + Y_ACC_WAIT <= time_elapsed)
   {
		Y.bearing = add_vect(Y.bearing.theta, Y.bearing.mag, Y.aim, ACC_AMT);
      if (Y.bearing.mag > Y_TOP_SPEED) Y.bearing.mag =  Y_TOP_SPEED;
		Y.lastacc = time_elapsed;
   }
   else if (DownFlag && Y.lastacc + Y_ACC_WAIT <= time_elapsed)
   {
   	Y.bearing.mag -= DEC_AMT;
      if (Y.bearing.mag < 0) Y.bearing.mag = 0;
      Y.lastacc = time_elapsed;
   }

   if (LeftFlag && RightFlag) ;
   else if (LeftFlag && Y.lastturn + Y_TURN_WAIT <= time_elapsed)
   {
   	EraseYShip(Y.x, Y.y);
   	Y.aim -= TURN_AMT;
      Y.lastturn = time_elapsed;
      DrawYShip(Y.x, Y.y, Y.aim);
   }                                                   
   else if (RightFlag && Y.lastturn + Y_TURN_WAIT <= time_elapsed)
   {
   	EraseYShip(Y.x, Y.y);
   	Y.aim += TURN_AMT;
      Y.lastturn = time_elapsed;
      DrawYShip(Y.x, Y.y, Y.aim);
   }

   if (EscFlag) quit = 1;
}
