#include <graphics.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

extern "C"
{
	#include "detect.h"
	#include "smix.h"
}

#include "Aa3Anim.H"
#include "Aa3Draw.H"
#include "Aa3Snds.H"
#include "Aa3Math.H"
#include "Aa3Const.H"

const float pi_3 = 3.14159/3;
const float pi_6 = 3.14159/6;
const float pi_180 = 3.14159/180;

// externs
extern unsigned long score;
extern char dashboard_change, dead;

extern char SFX;                // in aa3snds.cpp
extern SOUND *Sound[NUMSOUNDS];

void DrawDashboard(void)
{
   setviewport(0, 0, 639, 479, 1);
	setviewport(0, 0, 639, 19, 1);
   clearviewport();
	settextstyle(SMALL_FONT, HORIZ_DIR, 5);
   settextjustify(CENTER_TEXT, CENTER_TEXT);
   setcolor(LIGHTGRAY);
   rectangle(0, 0, 639, 19);
   setcolor(LIGHTBLUE);
   outtextxy(10, 8, "S");
   setcolor(DARKGRAY);
   rectangle(20, 5, 121, 14);
   rectangle(619, 5, 518, 14);
   setfillstyle(SOLID_FILL, LIGHTBLUE);
   bar(21, 6, 120, 13);
   setcolor(LIGHTCYAN);
   outtextxy(629, 8, "P");
   setfillstyle(SOLID_FILL, LIGHTCYAN);
   bar(618, 6, 519, 13);
   setcolor(GREEN);
   char score_str[20] = "Score: ";
   char num_str[11];
   ltoa(score, num_str, 10);
   strcat(score_str, num_str);
   outtextxy(319, 9, score_str);
   setviewport(0, 0, 639, 479, 1);
   setviewport(0, 450, 639, 479, 1);
   clearviewport();
   setcolor(LIGHTGRAY);
   rectangle(0, 0, 639, 29);
   setviewport(0, 0, 639, 479, 1);
   setviewport(0, 20, 639, 449, 1);
}

void UpdateDashboard(YShip &Y)
{
	setviewport(0, 0, 639, 479, 1);
	setviewport(0, 0, 639, 19, 1);
   clearviewport();
	settextstyle(SMALL_FONT, HORIZ_DIR, 5);
   settextjustify(CENTER_TEXT, CENTER_TEXT);
   setcolor(LIGHTGRAY);
   rectangle(0, 0, 639, 19);
   setcolor(LIGHTBLUE);
   outtextxy(10, 9, "S");
   setcolor(DARKGRAY);
   rectangle(20, 5, 121, 14);
   rectangle(619, 5, 518, 14);
   setfillstyle(SOLID_FILL, LIGHTBLUE);
   bar(21, 6, 20+Y.shields, 13);
   setcolor(LIGHTCYAN);
   outtextxy(629, 9, "P");
   setfillstyle(SOLID_FILL, LIGHTCYAN);
   bar(618, 6, 619-Y.power, 13);
   setcolor(GREEN);
   char score_str[20] = "Score: ";
   char num_str[11];
   ltoa(score, num_str, 10);
   strcat(score_str, num_str);
   outtextxy(319, 9, score_str);
   setviewport(0, 0, 639, 479, 1);
   setviewport(0, 20, 639, 449, 1);
}

void EraseYShip(float x, float y)
{
	setfillstyle(SOLID_FILL, BLACK);
   setcolor(BLACK);
   fillellipse(floor(x), floor(y), Y_SIDE_LENGTH+1, Y_SIDE_LENGTH+1);
}

void DrawYShip(float x, float y, float dir)
{
	setcolor(LIGHTGREEN);
   line(floor(x + Y_SIDE_LENGTH * cos(dir)), floor(y + Y_SIDE_LENGTH * sin(dir)), floor(x + Y_SIDE_LENGTH * cos(dir+2*pi_3)), floor(y+Y_SIDE_LENGTH * sin(dir+2*pi_3)));
   line(floor(x + Y_SIDE_LENGTH * cos(dir + 2*pi_3)), floor(y + Y_SIDE_LENGTH * sin(dir + 2*pi_3)), floor(x), floor(y));
   line(floor(x), floor(y), floor(x + Y_SIDE_LENGTH * cos(dir + 4*pi_3)), floor(y + Y_SIDE_LENGTH * sin(dir + 4*pi_3)));
   line(floor(x+Y_SIDE_LENGTH * cos(dir + 4*pi_3)), floor(y + Y_SIDE_LENGTH * sin(dir + 4*pi_3)), floor(x + Y_SIDE_LENGTH * cos(dir)), floor(y+Y_SIDE_LENGTH * sin(dir)));
}

void EraseYP(float x, float y)
{
	setfillstyle(SOLID_FILL, BLACK);
   bar(floor(x)-BULLET_RADIUS, floor(y)-BULLET_RADIUS,
       floor(x)+BULLET_RADIUS, floor(y)+BULLET_RADIUS);
}

void DrawYP(float x, float y, int answer)
{
	switch (answer)
   {
   	case 1 : setcolor(LIGHTRED);
      			setfillstyle(SOLID_FILL, LIGHTRED);
      			fillellipse(floor(x), floor(y), BULLET_RADIUS, BULLET_RADIUS);
               break;
      case 2 : setcolor(LIGHTCYAN);
      			setfillstyle(SOLID_FILL, LIGHTCYAN);
					fillellipse(floor(x), floor(y), BULLET_RADIUS, BULLET_RADIUS);
               break;
      case 3 : setcolor(LIGHTGREEN);
               setfillstyle(SOLID_FILL, LIGHTGREEN);
					fillellipse(floor(x), floor(y), BULLET_RADIUS, BULLET_RADIUS);
               break;
      case 4 : setcolor(YELLOW);
      			setfillstyle(SOLID_FILL, YELLOW);
					fillellipse(floor(x), floor(y), BULLET_RADIUS, BULLET_RADIUS);
               break;
      default : ;
   }
}

void EraseEP(float x, float y)
{
	setfillstyle(SOLID_FILL, BLACK);
   bar(floor(x)-E_PROJ_RADIUS, floor(y)-E_PROJ_RADIUS,
       floor(x)+E_PROJ_RADIUS, floor(y)+E_PROJ_RADIUS);
}

void DrawEP(float x, float y, int type)
{
	if (type)                                  // if flak
	{
   	setcolor(RED);
      setfillstyle(SOLID_FILL, RED);
   }
   else
   {
   	setcolor(LIGHTRED);
      setfillstyle(SOLID_FILL, LIGHTRED);
   }
   fillellipse(floor(x), floor(y), E_PROJ_RADIUS, E_PROJ_RADIUS);
}

void EraseE(float x, float y)
{
	setfillstyle(SOLID_FILL, BLACK);
   bar(floor(x)-ENEMY_RADIUS-2, floor(y)-ENEMY_RADIUS-2,
       floor(x)+ENEMY_RADIUS+2, floor(y)+ENEMY_RADIUS+2);
}

void DrawE(float x, float y, char type, char lock)
{
	switch (type)
   {
   	case 1 : setfillstyle(SOLID_FILL, LIGHTCYAN);
      			setcolor(LIGHTCYAN);
      		   break;
      case 2 : setfillstyle(CLOSE_DOT_FILL, LIGHTBLUE);
      			setcolor(YELLOW);
               break;
      case 3 : setfillstyle(HATCH_FILL, RED);
      			setcolor(YELLOW);
      			break;
      case 4 : setfillstyle(XHATCH_FILL, MAGENTA);
      			setcolor(YELLOW);
               break;
      default : ;
   }
   if (type > 0 && type < 5)
		fillellipse(floor(x), floor(y), ENEMY_RADIUS, ENEMY_RADIUS);
   if (lock)
   {
   	setcolor(LIGHTGREEN);
      line(floor(x)-(ENEMY_RADIUS+1), floor(y)-(ENEMY_RADIUS+1),
           floor(x)-(ENEMY_RADIUS+1)+TARGET_LENGTH, floor(y)-(ENEMY_RADIUS+1));
      line(floor(x)-(ENEMY_RADIUS+1), floor(y)-(ENEMY_RADIUS+1),
           floor(x)-(ENEMY_RADIUS+1), floor(y)-(ENEMY_RADIUS+1)+TARGET_LENGTH);

      line(floor(x)+(ENEMY_RADIUS+1), floor(y)-(ENEMY_RADIUS+1),
           floor(x)+(ENEMY_RADIUS+1)-TARGET_LENGTH, floor(y)-(ENEMY_RADIUS+1));
      line(floor(x)+(ENEMY_RADIUS+1), floor(y)-(ENEMY_RADIUS+1),
           floor(x)+(ENEMY_RADIUS+1), floor(y)-(ENEMY_RADIUS+1)+TARGET_LENGTH);

      line(floor(x)-(ENEMY_RADIUS+1), floor(y)+(ENEMY_RADIUS+1),
           floor(x)-(ENEMY_RADIUS+1), floor(y)+(ENEMY_RADIUS+1)-TARGET_LENGTH);
      line(floor(x)-(ENEMY_RADIUS+1), floor(y)+(ENEMY_RADIUS+1),
           floor(x)-(ENEMY_RADIUS+1)+TARGET_LENGTH, floor(y)+(ENEMY_RADIUS+1));

      line(floor(x)+(ENEMY_RADIUS+1), floor(y)+(ENEMY_RADIUS+1),
           floor(x)+(ENEMY_RADIUS+1), floor(y)+(ENEMY_RADIUS+1)-TARGET_LENGTH);
      line(floor(x)+(ENEMY_RADIUS+1), floor(y)+(ENEMY_RADIUS+1),
           floor(x)+(ENEMY_RADIUS+1)-TARGET_LENGTH, floor(y)+(ENEMY_RADIUS+1));
   }
}

void UpdateQuestion(char *question)
{
	setviewport(0, 0, 639, 479, 1);
	setviewport(1, 451, 638, 478, 1);
   clearviewport();
   if (question == NULL)
   {
   	setviewport(0, 0, 639, 479, 1);
   	setviewport(0, 20, 639, 449, 1);
   	return;
   }
   settextstyle(SMALL_FONT, HORIZ_DIR, 4);
   settextjustify(LEFT_TEXT, CENTER_TEXT);
   setcolor(GREEN);
   moveto(5, 5);
   int i;
   int len = strchr(question, '<') - question - 1;
   char tmp_string[2] = {' ', '\0'};
   for (i = 0; i < len; i++)
   {
   	tmp_string[0] = question[i];
   	outtext(tmp_string);
   }
   moveto(5, 20);
   int len2 = strlen(question);
   for (i = len; i < len2; i++)
	{
   	tmp_string[0] = question[i];
   	outtext(tmp_string);
   }
   setviewport(0, 0, 639, 479, 1);
   setviewport(0, 20, 639, 449, 1);
}

void Explode(float x, float y)
{
	setfillstyle(SOLID_FILL, LIGHTRED);
   setcolor(LIGHTRED);
   fillellipse(floor(x), floor(y), EXPLOSION_RADIUS, EXPLOSION_RADIUS);
   delay(EXPLOSION_DISPLAY_WAIT);
   setfillstyle(SOLID_FILL, BLACK);
   setcolor(BLACK);
   fillellipse(floor(x), floor(y), EXPLOSION_RADIUS, EXPLOSION_RADIUS);
   if (SFX)
   	start_sound(Sound[2], 2, 0);
}

void HitYou(void)
{
	if (SFX)
		start_sound(Sound[5], 5, 0);
}

void SmEx(float x, float y)
{
	setfillstyle(SOLID_FILL, LIGHTRED);
   setcolor(LIGHTRED);
   fillellipse(floor(x), floor(y), SMEX_RADIUS, SMEX_RADIUS);
   delay(EXPLOSION_DISPLAY_WAIT);
   setfillstyle(SOLID_FILL, BLACK);
   setcolor(BLACK);
   fillellipse(floor(x), floor(y), SMEX_RADIUS, SMEX_RADIUS);
}


void FlakExplode(float x, float y, YShip &Y)
{
	setcolor(RED);
   setfillstyle(SOLID_FILL, RED);
   fillellipse(floor(x), floor(y), FLAK_RADIUS, FLAK_RADIUS);
   delay(EXPLOSION_DISPLAY_WAIT);
   setcolor(BLACK);
   setfillstyle(SOLID_FILL, BLACK);
   fillellipse(floor(x), floor(y), FLAK_RADIUS, FLAK_RADIUS);

   if (floor(FLAK_RADIUS/floor(distance(x, y, Y.x, Y.y)+1) * 25.0/FLAK_RADIUS) > 0)
   {
   	Y.shields -= floor(FLAK_RADIUS/floor(distance(x, y, Y.x, Y.y)+1) * 25.0/FLAK_RADIUS);
		if (Y.shields < 0)
   	{
   		dead = 1;
      	Explode(Y.x, Y.y);
   	}
	   else
	   {
	   	dashboard_change = 1;
	      HitYou();
	   }
   }
   else if (SFX) start_sound(Sound[2], 2, 0);
}


void AddAlien(EShipPtr E, int question_num, ETypePtr ET)
{
	EShipPtr ins = new EShip;
   ins->ship_type = random(4)+1;
	switch (random(4))
   {
   	case 0 : ins->x = random(100)+270;
      			ins->y = 0;
               ins->bearing.theta = 4*pi_3 + random(60)*pi_180;
      			break;
      case 1 : ins->x = random(100)+270;
      			ins->y = 429;
               ins->bearing.theta = pi_3 + random(60)*pi_180;
      			break;
      case 2 : ins->x = 0;
      			ins->y = random(60)+190;
               ins->bearing.theta = -pi_6 + random(60)*pi_180;
               break;
      case 3 : ins->x = 639;
      			ins->y = random(60)+190;
               ins->bearing.theta = 5*pi_6 + random(60)*pi_180;
               break;
      default : ;
   }
	ins->lastmov = ins->lastshoot = ins->lastturn = 0;
   ins->bearing.mag = random(10)+1;

   ins->prev = E;
   ins->next = E->next;
   ins->next->prev = ins;
   E->next = ins;

   ins->question = question_num;

   ETypePtr cur = ET;
   for (int i = 0; i < question_num; i++)  cur = cur->next;
   ins->answer = cur->answer;
}
