#include <math.h>

#include "Aa3Anim.H"
#include "Aa3Math.H"

const float pi_2 = 3.14159/2;
const float pi = 3.14159;
const float pi_X_2 = 2*3.14159;

float get_theta(float x1, float y1, float x2, float y2)
{
	if (x1 == x2)
   	if (y1 > y2) return pi_2;
      else return -pi_2;
   else if (x1 < x2)
   	return atan( (y2-y1)/(x2-x1) );
   else
   	return atan( (y2-y1)/(x2-x1) ) + pi;
}


float distance(float x1, float y1, float x2, float y2)
{
	return sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
}

float delta_t(float t1, float t2)
{
	float dt = t2-t1;

   while (dt < -pi) dt += pi_X_2;
   while (dt > pi) dt -= pi_X_2;

   return abs(dt);
}

vector add_vect(float t1, float m1, float t2, float m2)
{
	float x1, y1, x2, y2;
   vector r;

   x1 = m1*cos(t1);       x2 = m2*cos(t2);
   y1 = m1*sin(t1);       y2 = m2*sin(t2);

   r.theta = get_theta(0, 0, x1+x2, y1+y2);
   r.mag = sqrt( (x1+x2)*(x1+x2) + (y1+y2)*(y1+y2) );

   return r;
}
